/* icode.c
	P. Chongstitvatana

	project Som						13 Sept 2003
*/

#include "compile.h"

int CP;			// pointer in CS

void readCode(FILE *fi){
	int i, start, end, c;
	fscanf(fi,"%d%d",&start,&end);
	for(i=start; i<=end; i++){
		fscanf(fi,"%d",&c);
		CS[i] = c;
	}
	CP = end+1;
}

void readData(FILE *fi){
	int i, start, end, c;
	fscanf(fi,"%d%d",&start,&end);
	for(i=start; i<=end; i++){
		fscanf(fi,"%d",&c);
		M[i] = c;
	}
	DS = end+1;
}

/* out code with argument */
void outa( int code, int arg){
	CS[CP] = (arg << 8 ) | (code & 255);
	CP++;
}

/* change arg, preserve code */
void patch( int ads, int v ){
	CS[ads] = (v << 8) | (CS[ads] & 255);
}
/*
void decode(int ip, int *code, int *data){
	*code = CS[ip] & 255;
	*data = CS[ip] >> 8;
}
void putcode(int ip, int code, int data){
	CS[ip] = (data << 8) | (code & 255);
}

// do a small improvement: short cut jump to ret, jmp to jmp
void improv2(int ref){
	int i,c1,d1,c2,d2;
	for( i=ref+1; i<CP-1; i++ ){
		decode(i,&c1,&d1);
		if( c1==icJmp || c1==icJt || c1==icJf ){
		    decode(i+d1,&c2,&d2);
			if( c1 == icJmp && c2 == icRet )
				putcode(i,icRet,d2);
			else if( c2==icJmp )
				patch(i,d1+d2);
		}
	}
}
*/

// ---------- string functions ----------

// pack C-string (char *) to S-string in M[] indexed by s1
void strpack(int s1, char *s2){
	uchar c1, c2, c3, c4;
	while( *s2 != 0 ){
		c1 = (*s2 != 0) ? *s2++ : 0;
		c2 = (*s2 != 0) ? *s2++ : 0;
		c3 = (*s2 != 0) ? *s2++ : 0;
		c4 = (*s2 != 0) ? *s2++ : 0;
		M[s1] = (((((((int)c1)<<8)|(int)c2)<<8)|
			(int)c3)<<8)|(int)c4;
		s1++;
	}
	M[s1] = 0;
}

// convert som-string to C-string
void strunpack(char *s1, int s2){
	int s;
	char c1, c2, c3, c4;
	while( M[s2] != 0 ){
	s = M[s2];
		c1 = (char)((s >> 24) & 255);
		c2 = (char)((s >> 16) & 255);
  		c3 = (char)((s >> 8) & 255);
   		c4 = (char)(s & 255);
   		if( c1 != 0 ) *s1++ = c1;
		if( c2 != 0 ) *s1++ = c2;
		if( c3 != 0 ) *s1++ = c3;
		if( c4 != 0 ) *s1++ = c4;
		s2++;
	}
	*s1 = 0;
}
/*
void prstr(int i){
	int c1,c2,c3,c4;

	while( M[i] != 0 ){
		c1 = (M[i] >> 24) & 255;
		c2 = (M[i] >> 16) & 255;
		c3 = (M[i] >> 8) & 255;
		c4 = M[i] & 255;
		if( c1 != 0 ) printf("%c",c1);
		if( c2 != 0 ) printf("%c",c2);
		if( c3 != 0 ) printf("%c",c3);
		if( c4 != 0 ) printf("%c",c4);
		i++;
	}
}
*/
